let canvas = document.getElementById("drawing");
let ctx = canvas.getContext("2d");

let widthDisplay = canvas.width;
let heightDisplay = canvas.height;

// объявляем переменные
const BACKGROUNDCOLOR = "#151515";
let inputAngle = document.getElementById("angle").value;
let inputWidth = document.getElementById("length").value;
let inputRecursion = document.getElementById("recursion").value;

function draw() {
    ctx.translate((widthDisplay / 2), (heightDisplay / 2) + 200);
    drawTree(inputRecursion, inputWidth, inputAngle);

}

function drawTree(r, w, a) {

    if (r <= 0) {
        return;
    }

    ctx.strokeStyle = "whitesmoke";

    ctx.beginPath();
  
    //размеры квадратов
    ctx.rect(0, 0, w, -w);
    ctx.stroke();

    let angle1 = a;
    let angle2 = 90 - a;
  
    let w1 = Math.cos(angle1 * (Math.PI / 180)) * w;
    let w2 = Math.cos(angle2 * (Math.PI / 180)) * w;
    
    let h = Math.sin(angle2 * (Math.PI / 180)) * w2;
    let x = Math.sqrt(Math.pow(w1, 2) - Math.pow(h, 2));
    let b = (Math.asin(h / w2) / Math.PI) * 180;

    ctx.save();
    ctx.translate(0, -w);
    ctx.rotate(-a * (Math.PI / 180));
    drawTree(r - 1, w1, a);
    ctx.restore();

    ctx.save();
    ctx.translate(x, -w - h);
    ctx.rotate(b * (Math.PI / 180));
    drawTree(r - 1, w2, a);
    ctx.restore();

}

// будет постоянно вызывать функцию очистки, обновления и рисования
function repeat() {
    updateValues();
    clearCanvas();
    draw();
    requestAnimationFrame(repeat)
}

// обновляем значения переменных 
function updateValues() {
    inputAngle = document.getElementById("angle").value;
    inputWidth = document.getElementById("length").value;
    inputRecursion = document.getElementById("recursion").value;
}

//очищаем канвас
function clearCanvas() {
    ctx.setTransform(1, 0, 0, 1, 0, 0);
    ctx.fillStyle = BACKGROUNDCOLOR;
    ctx.fillRect(0, 0, widthDisplay, heightDisplay);
}

requestAnimationFrame(repeat);